﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApp6
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            bmp = new Bitmap(1000, 1000);
            g = Graphics.FromImage(bmp);
            pictureBox1.Image = bmp;
        }
        Bitmap bmp;
        Graphics g;

        private void button1_Click_1(object sender, EventArgs e)
        {
            //Graphics g = CreateGraphics();
            g.DrawLine(Pens.Blue, 0, 0, 100, 100);

            int minx = 0;
            int miny = 0;
            Pen pero = new Pen(Color.Red, 3);
            pero.StartCap = System.Drawing.Drawing2D.LineCap.Round;
            pero.EndCap = System.Drawing.Drawing2D.LineCap.Round;


            for (int fi = 0; fi < 360 * 6; fi++)
            {
                int x = (int)(250 + 200 * Math.Sin(2 * fi / 2.00 / 360.00 * 2 * Math.PI));
                int y = (int)(250 + 200 * Math.Cos(3 * fi / 2.00 / 360.00 * 2 * Math.PI));
                //pero.Width = fi;
                //if (fi > 0)
                //    g.DrawLine(pero, minx, miny, x, y);
                g.FillRectangle(Brushes.Yellow, x, y, 50, 30);
                g.DrawRectangle(Pens.Black, x, y, 50, 30);

                minx = x;
                miny = y;
            }
            pictureBox1.Refresh();

        }
        private void button1_Click_2(object sender, EventArgs e)
        {
            //Graphics g = CreateGraphics();
            //g.DrawLine(Pens.Blue, 0, 0, 100, 100);

            int N = 16;
            int sx = pictureBox1.Width / N;
            int sy = pictureBox1.Height / N;
            for (int i = 0; i < N; i++)
            {
                for (int j = 0; j < N; j++)
                {
                    int x = i * sx;
                    int y = j * sy;
                    Color barva = Color.FromArgb(i * 17, j * 17, 255);
                    Brush stetec = new SolidBrush(barva);
                    g.FillRectangle(stetec, x, y, sx - 2, sy - 2);
                    g.DrawRectangle(Pens.Black, x, y, sx - 2, sy - 2);
                }
            }
            pictureBox1.Refresh();

        }
        private void button1_Click(object sender, EventArgs e)
        {
            //Graphics g = CreateGraphics();
            //g.DrawLine(Pens.Blue, 0, 0, 100, 100);

            Font pismo = new Font("Arial", 150);


            g.DrawString("ABCD", pismo, Brushes.Red, 10, 10);
        
            pictureBox1.Refresh();

        }
    }
}
