﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApp7
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click_1(object sender, EventArgs e)
        {
            Bitmap vzor = (Bitmap)pictureBox1.Image;
            Bitmap bmp = new Bitmap(1000, 1000);
            pictureBox2.Image = bmp;

            for (int x = 0; x < vzor.Width; x++)
            {
                for (int y = 0; y < vzor.Height; y++)
                {
                    int xx = x - (int)(20 * Math.Sin(y / 30.00));
                    xx = Math.Max(0, Math.Min(xx, vzor.Width - 1));
                    int yy = y - (int)(20 * Math.Sin(x / 30.00));
                    yy = Math.Max(0, Math.Min(yy, vzor.Height - 1));

                    xx = 200 + x / 2;
                    yy = 100 + y / 2;

                    xx = x;
                    yy = y;

                    Color c = vzor.GetPixel(xx, yy);
                    int R = c.R;
                    int G = c.G;
                    int B = c.B;

                    //R = 255 - R;
                    int svetlost
                        = (int)(R * 0.2989 + G * 0.5866 + B * (1 - 0.2989 - 0.5866));
                    c = Color.FromArgb(svetlost, svetlost, svetlost);

                    if (svetlost > 90)
                        c = Color.White;
                    else
                        c = Color.Black;

                    bmp.SetPixel(x, y, c);
                }
                pictureBox2.Refresh();

            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Bitmap vzor = (Bitmap)pictureBox1.Image;
            Bitmap bmp = new Bitmap(1000, 1000);
            pictureBox2.Image = bmp;

            int[] zbytky;
            int[] pristiZbytky = new int[vzor.Height];
            for (int x = 0; x < vzor.Width; x++)
            {
                zbytky = pristiZbytky;
                pristiZbytky = new int[vzor.Height];

                for (int y = 0; y < vzor.Height; y++)
                {
                    Color c = vzor.GetPixel(x, y);
                    int R = c.R;
                    int G = c.G;
                    int B = c.B;
                    int svetlost
                        = (int)(R * 0.2989 + G * 0.5866 + B * (1 - 0.2989 - 0.5866));
                    svetlost += zbytky[y];

                    int prah = 255;
                    if (svetlost > prah)
                    {
                        c = Color.White;
                        svetlost -= prah;
                    }
                    else
                        c = Color.Black;

                    if (y < vzor.Height - 1)
                        zbytky[y + 1] += svetlost / 4;
                    if (y > 0)
                        pristiZbytky[y - 1] += svetlost / 4;
                    pristiZbytky[y] += svetlost / 4;
                    if (y < vzor.Height - 1)
                        pristiZbytky[y + 1] += svetlost / 4;

                    bmp.SetPixel(x, y, c);
                }
                pictureBox2.Refresh();

            }
        }

        int x1;
        int y1;
        int x2;
        int y2;

        private void pictureBox1_MouseDown(object sender, MouseEventArgs e)
        {
            x1 = e.X;
            y1 = e.Y;
        }

        private void pictureBox1_MouseMove(object sender, MouseEventArgs e)
        {
            x2 = e.X;
            y2 = e.Y;

            if (e.Button==MouseButtons.Left)
            {
                pictureBox1.Refresh();

                Graphics g = pictureBox1.CreateGraphics();
                g.DrawRectangle(Pens.Blue, x1, y1, x2 - x1, y2 - y1);
            }
        }

        private void pictureBox1_MouseUp(object sender, MouseEventArgs e)
        {
            
        }


    }
}
